"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("./util"));
var decode = function (msg) {
    var resolvedPathResultsArr = util.searchAll(msg, "resolvedPathResults");
    var requestedPath = util.search(msg, "requestedPath");
    if (resolvedPathResultsArr) {
        var pathIncludesSearch = typeof requestedPath === "string" &&
            (requestedPath.includes("*") || requestedPath.includes("["));
        var pathSplit = requestedPath.split(".");
        var hasMultipleIndexes = util.hasMultipleIndexes(resolvedPathResultsArr
            .map(function (it) {
            return Object.keys(it.resultParams).map(function (p) { return it.resolvedPath + p; });
        })
            .flat(1), pathSplit);
        var shouldBeArray = pathIncludesSearch || hasMultipleIndexes;
        var unflattened = util.convertToNestedObject(resolvedPathResultsArr);
        var unwrapped = util.fullyUnwrapObject(unflattened, shouldBeArray);
        return [unwrapped];
    }
    return [null];
};
var encode = function (_a) {
    var paths = _a.paths;
    return ({
        lookup: "Msg",
        header: {
            msgId: util.uniq("GET@"),
            msgType: "GET",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                get: {
                    paramPaths: Array.isArray(paths) ? paths : [paths],
                },
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode,
};
